package com.aucma.base.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.aucma.common.utils.DateUtils;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.aucma.common.annotation.Log;
import com.aucma.common.core.controller.BaseController;
import com.aucma.common.core.domain.AjaxResult;
import com.aucma.common.enums.BusinessType;
import com.aucma.base.domain.RecordDnbInstant;
import com.aucma.base.service.IRecordDnbInstantService;
import com.aucma.common.utils.poi.ExcelUtil;
import com.aucma.common.core.page.TableDataInfo;

/**
 * 电实时数据Controller
 *
 * @author Yinq
 * @date 2023-09-26
 */
@RestController
@RequestMapping("/base/dnbInstant")
public class RecordDnbInstantController extends BaseController {
    @Autowired
    private IRecordDnbInstantService recordDnbInstantService;

    /**
     * 查询电实时数据列表
     */
    @PreAuthorize("@ss.hasPermi('base:dnbInstant:list')")
    @GetMapping("/list")
    public TableDataInfo list(RecordDnbInstant recordDnbInstant) {
        startPage();
        List<RecordDnbInstant> list = recordDnbInstantService.selectRecordDnbInstantList(recordDnbInstant);
        return getDataTable(list);
    }

    /**
     * 导出电实时数据列表
     */
    @PreAuthorize("@ss.hasPermi('base:dnbInstant:export')")
    @Log(title = "电实时数据", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, RecordDnbInstant recordDnbInstant) {
        List<RecordDnbInstant> list = recordDnbInstantService.selectRecordDnbInstantList(recordDnbInstant);
        ExcelUtil<RecordDnbInstant> util = new ExcelUtil<RecordDnbInstant>(RecordDnbInstant.class);
        util.exportExcel(response, list, "电实时数据数据");
    }

    /**
     * 获取电实时数据详细信息
     */
    @PreAuthorize("@ss.hasPermi('base:dnbInstant:query')")
    @GetMapping(value = "/{objId}")
    public AjaxResult getInfo(@PathVariable("objId") Long objId) {
        return success(recordDnbInstantService.selectRecordDnbInstantByObjId(objId));
    }

    /**
     * 新增电实时数据
     */
    @PreAuthorize("@ss.hasPermi('base:dnbInstant:add')")
    @Log(title = "电实时数据", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody RecordDnbInstant recordDnbInstant) {
        recordDnbInstant.setCreatedBy(getUsername());
        recordDnbInstant.setCreatedTime(DateUtils.getNowDate());
        return toAjax(recordDnbInstantService.insertRecordDnbInstant(recordDnbInstant));
    }

    /**
     * 修改电实时数据
     */
    @PreAuthorize("@ss.hasPermi('base:dnbInstant:edit')")
    @Log(title = "电实时数据", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody RecordDnbInstant recordDnbInstant) {
        recordDnbInstant.setUpdatedBy(getUsername());
        recordDnbInstant.setUpdatedTime(DateUtils.getNowDate());
        return toAjax(recordDnbInstantService.updateRecordDnbInstant(recordDnbInstant));
    }

    /**
     * 删除电实时数据
     */
    @PreAuthorize("@ss.hasPermi('base:dnbInstant:remove')")
    @Log(title = "电实时数据", businessType = BusinessType.DELETE)
    @DeleteMapping("/{objIds}")
    public AjaxResult remove(@PathVariable Long[] objIds) {
        return toAjax(recordDnbInstantService.deleteRecordDnbInstantByObjIds(objIds));
    }
}
